Index: /palm/trunk/SOURCE/microphysics_mod.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics_mod.f90	(revision 2291)
+++ /palm/trunk/SOURCE/microphysics_mod.f90	(revision 2292)
@@ -25,4 +25,17 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! - The process of activation is parameterized with a simple Twomey 
+!   activion scheme or with considering solution and curvature 
+!   effects (Khvorostyanov and Curry ,2006).
+! - The saturation adjustment scheme is replaced by the parameterization
+!   of condensation rates (Khairoutdinov and Kogan, 2000, Mon. Wea. Rev.,128).
+! - All other microphysical processes of Seifert and Beheng are used.
+!   Additionally, in those processes the reduction of cloud number concentration 
+!   is considered. 
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -123,8 +136,9 @@
     IMPLICIT NONE
 
-    LOGICAL ::  cloud_water_sedimentation = .FALSE.  !< cloud water sedimentation
-    LOGICAL ::  limiter_sedimentation = .TRUE.       !< sedimentation limiter
-    LOGICAL ::  collision_turbulence = .FALSE.       !< turbulence effects
-    LOGICAL ::  ventilation_effect = .TRUE.          !< ventilation effect
+    LOGICAL ::  cloud_water_sedimentation = .FALSE.       !< cloud water sedimentation
+    LOGICAL ::  curvature_solution_effects_bulk = .FALSE. !< flag for considering koehler theory
+    LOGICAL ::  limiter_sedimentation = .TRUE.            !< sedimentation limiter
+    LOGICAL ::  collision_turbulence = .FALSE.            !< turbulence effects
+    LOGICAL ::  ventilation_effect = .TRUE.               !< ventilation effect
 
     REAL(wp) ::  a_1 = 8.69E-4_wp          !< coef. in turb. parametrization (cm-2 s3)
@@ -147,4 +161,5 @@
     REAL(wp) ::  diff_coeff_l = 0.23E-4_wp  !< diffusivity of water vapor (m2 s-1)
     REAL(wp) ::  eps_sb = 1.0E-10_wp       !< threshold in two-moments scheme
+    REAL(wp) ::  eps_mr = 0.0_wp           !< threshold for morrison scheme
     REAL(wp) ::  k_cc = 9.44E09_wp         !< const. cloud-cloud kernel (m3 kg-2 s-1)
     REAL(wp) ::  k_cr0 = 4.33_wp           !< const. cloud-rain kernel (m3 kg-1 s-1)
@@ -161,4 +176,7 @@
     REAL(wp) ::  w_precipitation = 9.65_wp  !< maximum terminal velocity (m s-1)
     REAL(wp) ::  x0 = 2.6E-10_wp           !< separating drop mass (kg)
+    REAL(wp) ::  xamin = 5.24E-19_wp       !< average aerosol mass (kg) (~ 0.05Âµm)
+    REAL(wp) ::  xcmin = 4.18E-15_wp       !< minimum cloud drop size (kg) (~ 1Âµm)
+    REAL(wp) ::  xcmax = 2.6E-10_wp        !< maximum cloud drop size (kg) (~ 40Âµm)
     REAL(wp) ::  xrmin = 2.6E-10_wp        !< minimum rain drop size (kg)
     REAL(wp) ::  xrmax = 5.0E-6_wp         !< maximum rain drop site (kg)
@@ -167,4 +185,5 @@
     REAL(wp) ::  dpirho_l                  !< 6.0 / ( pi * rho_l )
     REAL(wp) ::  dt_micro                  !< microphysics time step
+    REAL(wp) ::  na_init = 100.0E6_wp      !< Total particle/aerosol concentration (cm-3)
     REAL(wp) ::  nc_const = 70.0E6_wp      !< cloud droplet concentration
     REAL(wp) ::  dt_precipitation = 100.0_wp !< timestep precipitation (s)
@@ -184,7 +203,9 @@
     PUBLIC microphysics_control, microphysics_init
 
-    PUBLIC cloud_water_sedimentation, collision_turbulence, c_sedimentation,   &
-           dt_precipitation, limiter_sedimentation, nc_const, sigma_gc,        &
+    PUBLIC cloud_water_sedimentation, collision_turbulence,                    &
+           curvature_solution_effects_bulk, c_sedimentation, dt_precipitation, &
+           limiter_sedimentation, na_init, nc_const, sigma_gc,                 &
            ventilation_effect
+           
 
     INTERFACE microphysics_control
@@ -198,4 +219,14 @@
     END INTERFACE adjust_cloud
 
+    INTERFACE activation
+       MODULE PROCEDURE activation
+       MODULE PROCEDURE activation_ij
+    END INTERFACE activation
+
+    INTERFACE condensation
+       MODULE PROCEDURE condensation
+       MODULE PROCEDURE condensation_ij
+    END INTERFACE condensation
+
     INTERFACE autoconversion
        MODULE PROCEDURE autoconversion
@@ -256,5 +287,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  microphysics_seifert
+           ONLY:  microphysics_morrison, microphysics_seifert
 
        USE indices,                                                            &
@@ -283,6 +314,10 @@
 !
 !--    Allocate 1D microphysics arrays
-       ALLOCATE ( nc_1d(nzb:nzt+1), pt_1d(nzb:nzt+1), q_1d(nzb:nzt+1),         &
+       ALLOCATE ( pt_1d(nzb:nzt+1), q_1d(nzb:nzt+1),         &
                   qc_1d(nzb:nzt+1) )
+
+       IF ( microphysics_morrison .OR. microphysics_seifert ) THEN
+          ALLOCATE ( nc_1d(nzb:nzt+1) )
+       ENDIF
 
        IF ( microphysics_seifert )  THEN
@@ -290,8 +325,4 @@
        ENDIF
 
-!
-!--    Initialze nc_1d with nc_const
-       nc_1d = nc_const
-
     END SUBROUTINE microphysics_init
 
@@ -313,6 +344,7 @@
            ONLY:  call_microphysics_at_all_substeps, dt_3d, g,                 &
                   intermediate_timestep_count, large_scale_forcing,            &
-                  lsf_surf, microphysics_kessler, microphysics_seifert,        &
-                  pt_surface, rho_surface,surface_pressure
+                  lsf_surf, microphysics_kessler, microphysics_morrison,       &
+                  microphysics_seifert, pt_surface,                            &
+                  rho_surface,surface_pressure
 
        USE indices,                                                            &
@@ -373,4 +405,6 @@
 
           CALL adjust_cloud
+          IF ( microphysics_morrison )  CALL activation
+          IF ( microphysics_morrison )  CALL condensation
           CALL autoconversion
           CALL accretion
@@ -396,8 +430,11 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  qr, nr
+           ONLY:  qc, nc, qr, nr
 
        USE cloud_parameters,                                                   &
            ONLY:  hyrho
+
+       USE control_parameters,                                                 &
+           ONLY:  microphysics_morrison
 
        USE cpulog,                                                             &
@@ -434,4 +471,16 @@
                    ENDIF
                 ENDIF
+                IF ( microphysics_morrison ) THEN
+                   IF ( qc(k,j,i) <= eps_sb )  THEN
+                      qc(k,j,i) = 0.0_wp
+                      nc(k,j,i) = 0.0_wp
+                   ELSE
+                      IF ( nc(k,j,i) * xcmin > qc(k,j,i) * hyrho(k) )  THEN
+                         nc(k,j,i) = qc(k,j,i) * hyrho(k) / xcmin *            &
+                                          MERGE( 1.0_wp, 0.0_wp,               &           
+                                              BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDIF
+                   ENDIF
+                ENDIF
              ENDDO
           ENDDO
@@ -442,4 +491,273 @@
     END SUBROUTINE adjust_cloud
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate number of activated condensation nucleii after simple activation
+!> scheme of Twomey, 1959.
+!------------------------------------------------------------------------------!
+    SUBROUTINE activation
+
+       USE arrays_3d,                                                          &
+           ONLY:  hyp, nc, nr, pt, q,  qc, qr
+
+       USE cloud_parameters,                                                   &
+           ONLY:  hyrho, l_d_cp, l_d_r, l_v, rho_l, r_v, t_d_pt
+
+       USE constants,                                                          &
+           ONLY:  pi
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE indices,                                                            &
+           ONLY:  nxlg, nxrg, nysg, nyng, nzb, nzt
+
+       USE kinds
+
+       USE control_parameters,                                                 &
+          ONLY: simulated_time
+
+       USE particle_attributes,                                                &
+          ONLY:  molecular_weight_of_solute, molecular_weight_of_water, rho_s, &
+              s1, s2, s3, vanthoff
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                 !<
+       INTEGER(iwp) ::  j                 !<
+       INTEGER(iwp) ::  k                 !<
+
+       REAL(wp)     ::  activ             !<
+       REAL(wp)     ::  afactor           !<
+       REAL(wp)     ::  alpha             !<
+       REAL(wp)     ::  beta_act          !<
+       REAL(wp)     ::  bfactor           !<
+       REAL(wp)     ::  e_s               !<
+       REAL(wp)     ::  k_act             !<
+       REAL(wp)     ::  n_act             !<
+       REAL(wp)     ::  n_ccn             !<
+       REAL(wp)     ::  q_s               !<
+       REAL(wp)     ::  rd0               !<
+       REAL(wp)     ::  s_0               !<
+       REAL(wp)     ::  sat               !<
+       REAL(wp)     ::  sat_max           !<
+       REAL(wp)     ::  sigma             !<
+       REAL(wp)     ::  t_int             !<
+       REAL(wp)     ::  t_l               !<
+
+       CALL cpu_log( log_point_s(65), 'activation', 'start' )
+
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             DO  k = nzb+1, nzt
+
+!
+!--             Actual liquid water temperature:
+                t_l = t_d_pt(k) * pt(k,j,i)
+
+!
+!--             Calculate actual temperature
+                t_int = pt(k,j,i) * ( hyp(k) / 100000.0_wp )**0.286_wp
+!
+!--             Saturation vapor pressure at t_l:
+                e_s = 610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /    &
+                                       ( t_l - 35.86_wp )                   &
+                                     )
+!
+!--             Computation of saturation humidity:
+                q_s   = 0.622_wp * e_s / ( hyp(k) - 0.378_wp * e_s )
+                alpha = 0.622_wp * l_d_r * l_d_cp / ( t_l * t_l )
+                q_s   = q_s * ( 1.0_wp + alpha * q(k,j,i) ) /               &
+                        ( 1.0_wp + alpha * q_s )
+
+!--             Supersaturation:
+                sat   = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
+
+!
+!--             Prescribe parameters for activation
+!--             (see: Bott + Trautmann, 2002, Atm. Res., 64)
+                k_act  = 0.7_wp 
+
+                IF ( sat >= 0.0 .AND. .NOT. curvature_solution_effects_bulk ) THEN
+!
+!--                Compute the number of activated Aerosols 
+!--                (see: Twomey, 1959, Pure and applied Geophysics, 43)
+                   n_act     = na_init * sat**k_act
+!
+!--                Compute the number of cloud droplets
+!--                (see: Morrison + Grabowski, 2007, JAS, 64)
+!                  activ = MAX( n_act - nc(k,j,i), 0.0_wp) / dt_micro
+
+!
+!--                Compute activation rate after Khairoutdinov and Kogan
+!--                (see: Khairoutdinov + Kogan, 2000, Mon. Wea. Rev., 128)   
+                   sat_max = 1.0_wp / 100.0_wp                  
+                   activ   = MAX( 0.0_wp, ( (na_init + nc(k,j,i) ) * MIN       & 
+                      ( 1.0_wp, ( sat / sat_max )**k_act) - nc(k,j,i) ) ) /    & 
+                       dt_micro
+                ELSEIF ( sat >= 0.0 .AND. curvature_solution_effects_bulk ) THEN
+!
+!--                Curvature effect (afactor) with surface tension 
+!--                parameterization by Straka (2009)
+                   sigma = 0.0761_wp - 0.000155_wp * ( t_int - 273.15_wp )
+                   afactor = 2.0_wp * sigma / ( rho_l * r_v * t_int )
+!
+!--                Solute effect (bfactor)
+                   bfactor = vanthoff * molecular_weight_of_water *            &
+                       rho_s / ( molecular_weight_of_solute * rho_l )
+
+!
+!--                Prescribe power index that describes the soluble fraction 
+!--                of an aerosol particle (beta) and mean geometric radius of
+!--                dry aerosol spectrum
+!--                (see: Morrison + Grabowski, 2007, JAS, 64)
+                   beta_act = 0.5_wp
+                   rd0      = 0.05E-6_wp
+!
+!--                Calculate mean geometric supersaturation (s_0) with 
+!--                parameterization by Khvorostyanov and Curry (2006)
+                   s_0   = rd0 **(- ( 1.0_wp + beta_act ) ) *                  &
+                       ( 4.0_wp * afactor**3 / ( 27.0_wp * bfactor ) )**0.5_wp
+
+!
+!--                Calculate number of activated CCN as a function of 
+!--                supersaturation and taking Koehler theory into account
+!--                (see: Khvorostyanov + Curry, 2006, J. Geo. Res., 111)       
+                   n_ccn = ( na_init / 2.0_wp ) * ( 1.0_wp - ERF(              & 
+                      LOG( s_0 / sat ) / ( SQRT(2.0_wp) * LOG(s1) ) ) )      
+                   activ = MAX( ( n_ccn - nc(k,j,i) ) / dt_micro, 0.0_wp )
+                ENDIF
+
+                nc(k,j,i) = MIN( (nc(k,j,i) + activ * dt_micro), na_init)
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(65), 'activation', 'stop' )
+
+    END SUBROUTINE activation
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate condensation rate for cloud water content (after Khairoutdinov and  
+!> Kogan, 2000).
+!------------------------------------------------------------------------------!
+    SUBROUTINE condensation
+
+       USE arrays_3d,                                                          &
+           ONLY:  hyp, nr, pt, q,  qc, qr, nc
+
+       USE cloud_parameters,                                                   &
+           ONLY:  hyrho, l_d_cp, l_d_r, l_v, r_v, t_d_pt
+
+       USE constants,                                                          &
+           ONLY:  pi
+
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
+       USE indices,                                                            &
+           ONLY:  nxlg, nxrg, nysg, nyng, nzb, nzt
+
+       USE kinds
+
+       USE control_parameters,                                                 &
+          ONLY: simulated_time
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                 !<
+       INTEGER(iwp) ::  j                 !<
+       INTEGER(iwp) ::  k                 !<
+
+       REAL(wp)     ::  alpha             !<
+       REAL(wp)     ::  cond              !<
+       REAL(wp)     ::  cond_max          !<
+       REAL(wp)     ::  dc                !<
+       REAL(wp)     ::  e_s               !<
+       REAL(wp)     ::  evap              !<
+       REAL(wp)     ::  evap_nc           !<
+       REAL(wp)     ::  g_fac             !<
+       REAL(wp)     ::  nc_0              !<
+       REAL(wp)     ::  q_s               !<
+       REAL(wp)     ::  sat               !<
+       REAL(wp)     ::  t_l               !<
+       REAL(wp)     ::  temp              !<
+       REAL(wp)     ::  xc                !<
+
+       CALL cpu_log( log_point_s(66), 'condensation', 'start' )
+
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             DO  k = nzb+1, nzt
+!
+!--             Actual liquid water temperature:
+                t_l = t_d_pt(k) * pt(k,j,i)
+!
+!--             Saturation vapor pressure at t_l:
+                e_s = 610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /       &
+                                       ( t_l - 35.86_wp )                      &
+                                     )
+!
+!--             Computation of saturation humidity:
+                q_s   = 0.622_wp * e_s / ( hyp(k) - 0.378_wp * e_s )
+                alpha = 0.622_wp * l_d_r * l_d_cp / ( t_l * t_l )
+                q_s   = q_s * ( 1.0_wp + alpha * q(k,j,i) ) /                  &
+                        ( 1.0_wp + alpha * q_s )
+
+!--             Supersaturation:
+                sat   = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
+
+!
+!--             Actual temperature:
+                temp = t_l + l_d_cp * ( qc(k,j,i) + qr(k,j,i) )
+
+                g_fac  = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) *        &
+                                    l_v / ( thermal_conductivity_l * temp )    &
+                                    + r_v * temp / ( diff_coeff_l * e_s )      &
+                                    )
+!
+!--             Mean weight of cloud drops
+                IF ( nc(k,j,i) <= 0.0_wp) CYCLE
+                xc = MAX( (hyrho(k) * qc(k,j,i) / nc(k,j,i)), xcmin)                
+!
+!--             Weight averaged diameter of cloud drops:
+                dc   = ( xc * dpirho_l )**( 1.0_wp / 3.0_wp )
+!
+!--             Integral diameter of cloud drops
+                nc_0 = nc(k,j,i) * dc                
+!
+!--             Condensation needs only to be calculated in supersaturated regions
+                IF ( sat > 0.0_wp )  THEN
+!
+!--                Condensation rate of cloud water content
+!--                after KK scheme.
+!--                (see: Khairoutdinov + Kogan, 2000, Mon. Wea. Rev.,128)
+                   cond      = 2.0_wp * pi * nc_0 * g_fac * sat / hyrho(k)
+                   cond_max  = q(k,j,i) - q_s - qc(k,j,i) - qr(k,j,i)
+                   cond      = MIN( cond, cond_max / dt_micro )
+               
+                   qc(k,j,i) = qc(k,j,i) + cond * dt_micro
+                ELSEIF ( sat < 0.0_wp ) THEN
+                   evap      = 2.0_wp * pi * nc_0 * g_fac * sat / hyrho(k)
+                   evap      = MAX( evap, -qc(k,j,i) / dt_micro )
+
+                   qc(k,j,i) = qc(k,j,i) + evap * dt_micro
+                ENDIF
+                IF ( nc(k,j,i) * xcmin > qc(k,j,i) * hyrho(k) )  THEN
+                   nc(k,j,i) = qc(k,j,i) * hyrho(k) / xcmin
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(66), 'condensation', 'stop' )
+
+    END SUBROUTINE condensation
+
 
 !------------------------------------------------------------------------------!
@@ -451,5 +769,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  diss, dzu, nr, qc, qr
+           ONLY:  diss, dzu, nc, nr, qc, qr
 
        USE cloud_parameters,                                                   &
@@ -457,5 +775,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  rho_surface
+           ONLY:  microphysics_morrison, rho_surface
 
        USE cpulog,                                                             &
@@ -482,4 +800,5 @@
        REAL(wp)     ::  k_au              !<
        REAL(wp)     ::  l_mix             !<
+       REAL(wp)     ::  nc_auto           !<
        REAL(wp)     ::  nu_c              !<
        REAL(wp)     ::  phi_au            !<
@@ -500,4 +819,6 @@
                 flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
+                nc_auto = MERGE( nc(k,j,i), nc_const, microphysics_morrison )
+
                 IF ( qc(k,j,i) > eps_sb )  THEN
 
@@ -518,5 +839,5 @@
 !
 !--                Mean weight of cloud droplets:
-                   xc = hyrho(k) * qc(k,j,i) / nc_const
+                   xc = hyrho(k) * qc(k,j,i) / nc_auto
 !
 !--                Parameterized turbulence effects on autoconversion (Seifert,
@@ -569,4 +890,8 @@
                    nr(k,j,i) = nr(k,j,i) + autocon / x0 * hyrho(k) * dt_micro  &
                                                               * flag
+                   IF ( microphysics_morrison ) THEN
+                      nc(k,j,i) = nc(k,j,i) - MIN( nc(k,j,i), 2.0_wp *         & 
+                                    autocon / x0 * hyrho(k) * dt_micro * flag )
+                   ENDIF
 
                 ENDIF
@@ -654,5 +979,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  diss, qc, qr
+           ONLY:  diss, qc, qr, nc
 
        USE cloud_parameters,                                                   &
@@ -660,5 +985,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  rho_surface
+           ONLY:  microphysics_morrison, rho_surface
 
        USE cpulog,                                                             &
@@ -679,6 +1004,9 @@
        REAL(wp)     ::  flag              !< flag to mask topography grid points
        REAL(wp)     ::  k_cr              !<
+       REAL(wp)     ::  nc_accr           !<
        REAL(wp)     ::  phi_ac            !<
        REAL(wp)     ::  tau_cloud         !<
+       REAL(wp)     ::  xc                !<
+
 
        CALL cpu_log( log_point_s(56), 'accretion', 'start' )
@@ -691,5 +1019,8 @@
                 flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
-                IF ( ( qc(k,j,i) > eps_sb )  .AND.  ( qr(k,j,i) > eps_sb ) )  THEN
+                nc_accr = MERGE( nc(k,j,i), nc_const, microphysics_morrison )
+
+                IF ( ( qc(k,j,i) > eps_sb )  .AND.  ( qr(k,j,i) > eps_sb )    &
+                                             .AND.  ( nc_accr > eps_mr ) ) THEN
 !
 !--                Intern time scale of coagulation (Seifert and Beheng, 2006):
@@ -699,4 +1030,8 @@
 !--                Beheng, 2001):
                    phi_ac = ( tau_cloud / ( tau_cloud + 5.0E-5_wp ) )**4
+
+!
+!--                Mean weight of cloud drops
+                   xc = MAX( (hyrho(k) * qc(k,j,i) / nc_accr), xcmin)      
 !
 !--                Parameterized turbulence effects on autoconversion (Seifert,
@@ -719,4 +1054,8 @@
                    qr(k,j,i) = qr(k,j,i) + accr * dt_micro * flag
                    qc(k,j,i) = qc(k,j,i) - accr * dt_micro * flag
+                   IF ( microphysics_morrison )  THEN
+                      nc(k,j,i) = nc(k,j,i) - MIN( nc(k,j,i),                  &
+                                         accr / xc * hyrho(k) * dt_micro * flag)
+                   ENDIF
 
                 ENDIF
@@ -976,5 +1315,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, dzu, pt, prr, q, qc
+           ONLY:  ddzu, dzu, nc, pt, prr, q, qc
 
        USE cloud_parameters,                                                   &
@@ -982,5 +1321,6 @@
 
        USE control_parameters,                                                 &
-           ONLY:  call_microphysics_at_all_substeps, intermediate_timestep_count
+           ONLY:  call_microphysics_at_all_substeps,                           & 
+                  intermediate_timestep_count, microphysics_morrison
 
        USE cpulog,                                                             &
@@ -1002,6 +1342,10 @@
        INTEGER(iwp) ::  k             !<
 
-       REAL(wp)                       ::  flag   !< flag to mask topography grid points
+       REAL(wp) ::  flag              !< flag to mask topography grid points
+       REAL(wp) ::  nc_sedi           !<
+
        REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_qc !<
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_nc !<
+
 
        CALL cpu_log( log_point_s(59), 'sed_cloud', 'start' )
@@ -1015,7 +1359,28 @@
 !--             Predetermine flag to mask topography
                 flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+                nc_sedi = MERGE ( nc(k,j,i), nc_const, microphysics_morrison )
+
+!
+!--             Sedimentation fluxes for number concentration are only calculated
+!--             for cloud_scheme = 'morrison'
+                IF ( microphysics_morrison ) THEN
+                   IF ( qc(k,j,i) > eps_sb  .AND.  nc(k,j,i) > eps_mr )  THEN
+                      sed_nc(k) = sed_qc_const *                               & 
+                              ( qc(k,j,i) * hyrho(k) )**( 2.0_wp / 3.0_wp ) *  &
+                              ( nc(k,j,i) )**( 1.0_wp / 3.0_wp )
+                   ELSE
+                      sed_nc(k) = 0.0_wp
+                   ENDIF
+
+                   sed_nc(k) = MIN( sed_nc(k), hyrho(k) * dzu(k+1) *           &
+                                    nc(k,j,i) / dt_micro + sed_nc(k+1)         &
+                                  ) * flag
+
+                   nc(k,j,i) = nc(k,j,i) + ( sed_nc(k+1) - sed_nc(k) ) *       &
+                                         ddzu(k+1) / hyrho(k) * dt_micro * flag
+                ENDIF
 
                 IF ( qc(k,j,i) > eps_sb )  THEN
-                   sed_qc(k) = sed_qc_const * nc_const**( -2.0_wp / 3.0_wp ) * &
+                   sed_qc(k) = sed_qc_const * nc_sedi**( -2.0_wp / 3.0_wp ) *  &
                                ( qc(k,j,i) * hyrho(k) )**( 5.0_wp / 3.0_wp ) * &
                                                                            flag
@@ -1389,5 +1754,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  hyp, nr, pt, pt_init, prr, q, qc, qr, zu
+           ONLY:  hyp, nc, nr, pt, pt_init, prr, q, qc, qr, zu
 
        USE cloud_parameters,                                                   &
@@ -1397,6 +1762,7 @@
            ONLY:  call_microphysics_at_all_substeps, dt_3d, g,                 &
                   intermediate_timestep_count, large_scale_forcing,            &
-                  lsf_surf, microphysics_seifert, microphysics_kessler,        &
-                  pt_surface, rho_surface, surface_pressure
+                  lsf_surf, microphysics_morrison, microphysics_seifert,       &
+                  microphysics_kessler, pt_surface, rho_surface,               &
+                  surface_pressure
 
        USE indices,                                                            &
@@ -1448,9 +1814,12 @@
        pt_1d(:) = pt(:,j,i)
        qc_1d(:) = qc(:,j,i)
-       nc_1d(:) = nc_const
        IF ( microphysics_seifert )  THEN
           qr_1d(:) = qr(:,j,i)
           nr_1d(:) = nr(:,j,i)
        ENDIF
+       IF ( microphysics_morrison )  THEN
+          nc_1d(:) = nc(:,j,i)
+       ENDIF
+
 
 !
@@ -1468,4 +1837,6 @@
 
           CALL adjust_cloud( i,j )
+          IF ( microphysics_morrison ) CALL activation( i,j )
+          IF ( microphysics_morrison ) CALL condensation( i,j )
           CALL autoconversion( i,j )
           CALL accretion( i,j )
@@ -1483,4 +1854,8 @@
        q(:,j,i)  = q_1d(:)
        pt(:,j,i) = pt_1d(:)
+       IF ( microphysics_morrison ) THEN
+          qc(:,j,i) = qc_1d(:)
+          nc(:,j,i) = nc_1d(:)
+       ENDIF
        IF ( microphysics_seifert )  THEN
           qr(:,j,i) = qr_1d(:)
@@ -1503,4 +1878,7 @@
        USE cloud_parameters,                                                   &
            ONLY:  hyrho
+
+       USE control_parameters,                                                 &
+           ONLY: microphysics_morrison
 
        USE indices,                                                            &
